#!python3
# ADC2019 system module

import json

from roles import Host, Solver

config = None
role = None

def init(args):
    
    if ('config' in args) and (args['config'] is not None):
        load_config(args['config'])

def load_config(path):
    global config
    global role
    
    with open(path, 'r') as fp:
        config = json.load(fp)

    if 'role' in config:
        set_role(config['role'], config)

def set_role(role_name, config_data):
    global role

    if role_name == 'host':
        role = Host(config_data)
    elif role_name == 'solver':
        role = Solver(config_data)

def call_api(method, cmd, params):

    if role is not None:
        return role.call_api(method, cmd, params)
    else:
        if cmd == 'role':
            if method == 'POST':
                set_role(params['role'], params)
                return {'role': role.type}
            else:
                return {'role': 'Undefined'}
        else:
            return None
